#!/usr/bin/perl -w
use strict;
use POSIX qw(strftime);
use POSIX qw(locale_h);

setlocale(LC_ALL,'C');

BEGIN {
    unshift @::INC, '.';
}

use TrafD;

#die 'No trafd file specified'.v10 unless @ARGV;

die "File name should be specified\n" unless $ARGV[0];

#my $TDh = TrafD->open() or die "Can not open file $ARGV[0]\n";
my $TDh = TrafD->open($ARGV[0]) or die "Can not open file $ARGV[0]\n";
#my $TDh = TrafD->open('Sample/bpft.data0');
#my $TDh = TrafD->open('Sample/trafd.data0');
my ($name) = $TDh->{FileName}; # =~ m!^(?:.*/)?([^/]+)$!o;

while(
    my ($NoRec,$STimeSec,$STimeUSec,$ETimeSec,$ETimeUSec,@Records) =
	$TDh->ReadSave
) {

    my ($SumBytes, $SumDataBytes) = (0,0);

    for my $record ( @Records ) {
	$SumBytes     += $$record[5];
	$SumDataBytes += $$record[6];
    }

    #@Records = sort { $$a[1] <=> $$b[1] } @Records;
    #@Records = sort { $$b[5] <=> $$a[5] } @Records;

    printf
	''.v10.
	' (%s) serv.willcom.ru at %s - %s'.v10.
	' Summary: %g data bytes, %g all bytes, %g records'.v10.
	'     From           Port         To            Port  Proto     Data       All'.v10,
	$name,
	strftime('%b %e %T',localtime $STimeSec),
	strftime('%b %e %T',localtime $ETimeSec),
	$SumDataBytes,$SumBytes,$NoRec;

    for my $record ( @Records ) {
	my ($src_port,$dst_port) = @$record[3..4];
	my $proto = $$record[2];

	if( 0 ) {
	    if( $TDh->{BPFTVers} == 3 ) {
		if( $src_port == 0 ) {
		    $src_port = 'client';
		}
		elsif( $src_port == -1 ) {
		    $src_port = 'none';
		}
		else {
		    $src_port .= '';
		}

		if( $dst_port == 0 ) {
		    $dst_port = 'client';
		}
		elsif( $dst_port == -1 ) {
		    $dst_port = 'none';
		}
		else {
		    $dst_port .= '';
		}
	    }
	    else {
		$src_port .= '';
		$dst_port .= '';
	    }
	    $proto = $proto==2?'igmp':$proto==6?'tcp':$proto==17?'udp':'unkn'; 
	}

	printf '%-18.18s %-6.6s  %-18.18s %-6.6s  %-4.4s %9lu %10lu'.v10,
	    TrafD::InetN2A($$record[0]),$src_port,
	    TrafD::InetN2A($$record[1]),$dst_port,
	    $proto,$$record[6],$$record[5];
    }
}
exit 0;

